/*
* Copyright 2020 Kumori systems S.L.
*
* Licensed under the EUPL, Version 1.2 or – as soon they
* will be approved by the European Commission - subsequent
* versions of the EUPL (the "Licence");
* You may not use this work except in compliance with the
* Licence.
* You may obtain a copy of the Licence at:
*
* https://joinup.ec.europa.eu/software/page/eupl
*
* Unless required by applicable law or agreed to in
* writing, software distributed under the Licence is
* distributed on an "AS IS" basis,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
* express or implied.
* See the Licence for the specific language governing
* permissions and limitations under the Licence.
 */
// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	"context"

	v1beta2 "gitlab.com/kumori-systems/community/libraries/clusterapi-client-go/pkg/apis_aws/aws/v1beta2"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeAWSClusterTemplates implements AWSClusterTemplateInterface
type FakeAWSClusterTemplates struct {
	Fake *FakeInfrastructureV1beta2
	ns   string
}

var awsclustertemplatesResource = schema.GroupVersionResource{Group: "infrastructure.cluster.x-k8s.io", Version: "v1beta2", Resource: "awsclustertemplates"}

var awsclustertemplatesKind = schema.GroupVersionKind{Group: "infrastructure.cluster.x-k8s.io", Version: "v1beta2", Kind: "AWSClusterTemplate"}

// Get takes name of the aWSClusterTemplate, and returns the corresponding aWSClusterTemplate object, and an error if there is any.
func (c *FakeAWSClusterTemplates) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1beta2.AWSClusterTemplate, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(awsclustertemplatesResource, c.ns, name), &v1beta2.AWSClusterTemplate{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta2.AWSClusterTemplate), err
}

// List takes label and field selectors, and returns the list of AWSClusterTemplates that match those selectors.
func (c *FakeAWSClusterTemplates) List(ctx context.Context, opts v1.ListOptions) (result *v1beta2.AWSClusterTemplateList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(awsclustertemplatesResource, awsclustertemplatesKind, c.ns, opts), &v1beta2.AWSClusterTemplateList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v1beta2.AWSClusterTemplateList{ListMeta: obj.(*v1beta2.AWSClusterTemplateList).ListMeta}
	for _, item := range obj.(*v1beta2.AWSClusterTemplateList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested aWSClusterTemplates.
func (c *FakeAWSClusterTemplates) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(awsclustertemplatesResource, c.ns, opts))

}

// Create takes the representation of a aWSClusterTemplate and creates it.  Returns the server's representation of the aWSClusterTemplate, and an error, if there is any.
func (c *FakeAWSClusterTemplates) Create(ctx context.Context, aWSClusterTemplate *v1beta2.AWSClusterTemplate, opts v1.CreateOptions) (result *v1beta2.AWSClusterTemplate, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(awsclustertemplatesResource, c.ns, aWSClusterTemplate), &v1beta2.AWSClusterTemplate{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta2.AWSClusterTemplate), err
}

// Update takes the representation of a aWSClusterTemplate and updates it. Returns the server's representation of the aWSClusterTemplate, and an error, if there is any.
func (c *FakeAWSClusterTemplates) Update(ctx context.Context, aWSClusterTemplate *v1beta2.AWSClusterTemplate, opts v1.UpdateOptions) (result *v1beta2.AWSClusterTemplate, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(awsclustertemplatesResource, c.ns, aWSClusterTemplate), &v1beta2.AWSClusterTemplate{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta2.AWSClusterTemplate), err
}

// Delete takes name of the aWSClusterTemplate and deletes it. Returns an error if one occurs.
func (c *FakeAWSClusterTemplates) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteActionWithOptions(awsclustertemplatesResource, c.ns, name, opts), &v1beta2.AWSClusterTemplate{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeAWSClusterTemplates) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(awsclustertemplatesResource, c.ns, listOpts)

	_, err := c.Fake.Invokes(action, &v1beta2.AWSClusterTemplateList{})
	return err
}

// Patch applies the patch and returns the patched aWSClusterTemplate.
func (c *FakeAWSClusterTemplates) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1beta2.AWSClusterTemplate, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(awsclustertemplatesResource, c.ns, name, pt, data, subresources...), &v1beta2.AWSClusterTemplate{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta2.AWSClusterTemplate), err
}
